{****************************************************************************
 * Author           : Stefan Goehler, Germany                               *
 * Version          : official 1.0                                          *
 *******                                                                    *
 * my mail-adress   : goehler@geocities.com                                 *
 * my homepage      : www.geocities.com/SiliconValley/Bay/9553              *
 ****************************************************************************}

unit fadelib;
interface
uses graphics;

procedure fade2white;
procedure fadeout;
procedure fadeshades;
procedure faderollo;
procedure fadein;

implementation
var i,i2 : integer;

procedure fade2white;
begin
getpal;
for i2 := 63 downto 0 do begin
        waitretrace;
    for i := 1 to 255 do begin
        if Pal^[i].r < 63 then inc(Pal^[i].r);
        if Pal^[i].g < 63 then inc(Pal^[i].g);
        if Pal^[i].b < 63 then inc(Pal^[i].b);
{        Port[$3C8] := i;
        Port[$3C9] := Pal^[i].r;
        Port[$3C9] := Pal^[i].g;
        Port[$3C9] := Pal^[i].b;}
    end;
setpal;
end;
end;

procedure fadeout;
begin
getpal;
for i2 := 63 downto 0 do begin
        waitretrace;
    for i := 1 to 255 do begin
        if Pal^[i].r > 0 then dec(Pal^[i].r);
        if Pal^[i].g > 0 then dec(Pal^[i].g);
        if Pal^[i].b > 0 then dec(Pal^[i].b);
{        Port[$3C8] := i;
        Port[$3C9] := Pal^[i].r;
        Port[$3C9] := Pal^[i].g;
        Port[$3C9] := Pal^[i].b;}
    end;
setpal;
end;
end;

procedure fadeshades;
begin
fade2white;
for i := 0 to mxx div 32 do
for i2 := 0 to 31 do begin
setcolor(i2+1+i*2);
line(i*32+i2,0,i*32+i2,mxy);
end;
for i := 1 to 64 do begin
setrgbpalette(i,31+i div 2-1,31+i div 2-1,31+i div 2-1);
end;
fadeout;
end;

procedure faderollo;
begin
for i := 0 to 19 do begin
waitretrace;
for i2 := 0 to getmaxy div 10 do hline(0,i2*20+i,maxx,black);
end;
end;

procedure fadein;
var
pal2 : ^paltype;
i2 : integer;
begin
new(pal2);
pal2^ := pal^;
for i := 0 to 255 do begin
pal^[i].r := 0;
pal^[i].g := 0;
pal^[i].b := 0;
end;
for i2 := 0 to 63 do begin
for i := 0 to 255 do begin
if pal^[i].r < pal2^[i].r then inc(pal^[i].r);
if pal^[i].g < pal2^[i].g then inc(pal^[i].g);
if pal^[i].b < pal2^[i].b then inc(pal^[i].b);
end;
waitretrace;
setpal;
end;
dispose(pal2);
end;


begin
end.





